using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace ConsoleApp4
{
    internal class Program
    {
        static ulong Plazma(ulong[] d, ulong[] p, ulong pitanje)
        {
            ulong sum = 0;
            if (d[0] > pitanje) return sum;
            for (ulong i = 0; i < (ulong)d.Length; i++)
            {
                if (d[i] + p[i] >= pitanje && d[i] < pitanje)
                {
                    sum += pitanje - d[i];
                    return sum + 1;
                }
                else
                {
                    sum += p[i];
                }
            }
            return sum;
        }

        static void Main()
        {
            string[] s = Console.ReadLine().Split();
            ulong N = ulong.Parse(s[0]);
            ulong Q = ulong.Parse(s[1]);

            ulong[] d = new ulong[N];
            ulong[] p = new ulong[N];
            ulong[] pitanja = new ulong[Q];

            for (ulong i = 0; i < N; i++)
            {
                s = Console.ReadLine().Split();
                d[i] = ulong.Parse(s[0]);
                p[i] = ulong.Parse(s[1]);
            }

            for (ulong i = 0; i < Q; i++)
            {
                pitanja[i] = ulong.Parse(Console.ReadLine());
            }

            for (ulong i = 0; i < (ulong)pitanja.Length; i++)
            {
                Console.WriteLine(Plazma(d, p, pitanja[i]));
            }
        }
    }
}